sap.ui.core.Control.extend("sap.sf.learning.instructor.control.ThumbnailImage", {    
    metadata : {
        properties : {
            "src" : {type : "sap.ui.core.URI", group : "Data", defaultValue : null},
            "width" : {type : "sap.ui.core.CSSSize", group : "Appearance", defaultValue : "3rem"},
            "height" : {type : "sap.ui.core.CSSSize", group : "Appearance", defaultValue : "3rem"},
            // background-size: auto|length|cover|contain|initial|inherit;
            "backgroundSize" : {type : "string", group : "Misc", defaultValue : "cover"},
            "backgroundPosition" : {type : "string", group : "Misc", defaultValue : "center"},
            // background-repeat: repeat|repeat-x|repeat-y|no-repeat|initial|inherit;
            "backgroundRepeat" : {type : "string", group : "Misc", defaultValue : "no-repeat"},
            "text1": {type: "string", group: "Misc", defaultValue: ""},
            "text2": {type: "string", group: "Misc", defaultValue: ""},
            "text3": {type: "string", group: "Misc", defaultValue: ""},
            "alt": {type: "string", group: "Misc", defaultValue: ""},
            "title": {type: "string", group: "Misc", defaultValue: ""}
        }
    },
      
    renderer : function(oRm, oImage) {
        oRm.write("<div role='img' "); 
        oRm.writeControlData(oImage);
        
        // Styles
        oRm.addStyle("background-image", "url(" + oImage.getSrc() + ")");
        oRm.addStyle("background-position", oImage.getBackgroundPosition());
        oRm.addStyle("background-repeat", oImage.getBackgroundRepeat());
        oRm.addStyle("background-size", oImage.getBackgroundSize());
        
        // Dimensions
        if (oImage.getWidth() && oImage.getWidth() !== '') {
            oRm.addStyle("width", oImage.getWidth());
        }
        if (oImage.getHeight() && oImage.getHeight() !== '') {
            oRm.addStyle("height", oImage.getHeight());
        }
        oRm.writeStyles(); // eof Styles
        
        // Classes
        oRm.addClass("BackgroundImage");
        oRm.writeClasses(); // eof Classes
        
        // alt and title
        oRm.write(" alt='" + oImage.getAlt() + "'");
        
        var title = oImage.getTitle();
        
        if(!title) {
        	title = oImage.getAlt();
        }
        
        oRm.write(" title='" + title + "'");
        
        oRm.write(">");
	    if (oImage.getText1() && oImage.getText1() !== '') {
	       	oRm.write("<div class='transbox'");
	       	oRm.writeClasses(); 
	       	oRm.write(">");
		        oRm.write("<div class='dateTextWrapper'>");
		        if (oImage.getText1() && oImage.getText1() !== '') {
		        	oRm.write("<div class='dateText'>");
		        	oRm.write("<span");
		        	oRm.write(" title='" + oImage.getText1());
		        	oRm.write("'>");
		        	oRm.write(oImage.getText1());
		        	oRm.write("</span>");
		        	oRm.write("</div>");
		        }
		        if (oImage.getText2() && oImage.getText2() !== '') {
		        	oRm.write("<div class='dateText'>");
		        	oRm.write("<span");
		        	oRm.write(" title='" + oImage.getText2());
		        	oRm.write("'>");
		        	oRm.write(oImage.getText2());
		        	oRm.write("</span>");
		        	oRm.write("</div>");
		        }
		        if (oImage.getText3() && oImage.getText3() !== '') {
		        	oRm.write("<div class='dateText'>");
		        	oRm.write("<span");
		        	oRm.write(" title='" + oImage.getText3());
		        	oRm.write("'>");
		        	oRm.write(oImage.getText3());
		        	oRm.write("</span>");
		        	oRm.write("</div>");
		        }
		      oRm.write("</div>");
	        oRm.write("</div>");
        }
      oRm.write("</div>");
    }    
});